Package com.google.javascript.rhino.jstype

# Class TemplateType

java.lang.Object
com.google.javascript.rhino.jstype.JSType
com.google.javascript.rhino.jstype.ObjectType
com.google.javascript.rhino.jstype.TemplateType

All Implemented Interfaces:
  `StaticScope<JSType>`, `Serializable`

public class TemplateType extends ObjectType

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class com.google.javascript.rhino.jstype.JSType

`JSType.TypePair`

## Field Summary

### Fields inherited from class com.google.javascript.rhino.jstype.JSType

`EMPTY_TYPE_COMPONENT, ENUMDECL, NOT_A_CLASS, NOT_A_TYPE, NOT_ENUMDECL, templateTypeMap, UNKNOWN_NAME`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canBeCalled()`
This predicate is used to test whether a given type can be used as the 'function' in a function call.
`JSType`
`collapseUnion()`
Gets the least supertype of this that's not a union.
`JSType`
`findPropertyType(String propertyName)`
Coerces this type to an Object type, then gets the type of the property whose name is given.
`FunctionType`
`getConstructor()`
Gets this object's constructor.
`Iterable<ObjectType>`
`getCtorImplementedInterfaces()`
Gets the interfaces implemented by the ctor associated with this type.
`ObjectType`
`getImplicitPrototype()`
Gets the implicit prototype (a.k.a.
`JSDocInfo`
`getJSDocInfo()`
Gets the docInfo for this type.
`FunctionType`
`getOwnerFunction()`
Gets the owner of this if it's a function prototype.
`String`
`getReferenceName()`
Gets the reference name for this object.
`TemplateTypeMap`
`getTemplateTypeMap()`
Returns the template type map associated with this type.
`com.google.common.collect.ImmutableList<JSType>`
`getTemplateTypes()`
Gets the declared default element type.
`JSType`
`getTypeOfThis()`
Returns the expected type of `this` in the current scope.
`boolean`
`hasAnyTemplateTypesInternal()`
`int`
`hashCode()`
`boolean`
`hasReferenceName()`
Returns true if the object is named.
`boolean`
`isAllType()`
`boolean`
`isCheckedUnknownType()`
`boolean`
`isConstructor()`
Whether this type is a `FunctionType` that is a constructor or a named type that points to such a type.
`boolean`
`isDict()`
Returns true iff `this` can be a `dict`.
`boolean`
`isInstanceType()`
Whether this type is an Instance object of some constructor.
`boolean`
`isInterface()`
Whether this type is a `FunctionType` that is an interface or a named type that points to such a type.
`boolean`
`isNativeObjectType()`
Whether this is a built-in object.
`boolean`
`isNominalType()`
Whether this type is a nominal type (a named instance object or a named enum).
`boolean`
`isNoObjectType()`
`boolean`
`isNoResolvedType()`
`boolean`
`isNoType()`
`boolean`
`isNullable()`
Tests whether this type is nullable.
`boolean`
`isOrdinaryFunction()`
Whether this type is a `FunctionType` that is an ordinary function or a named type that points to such a type.
`boolean`
`isStruct()`
Returns true iff `this` can be a `struct`.
`boolean`
`isSubtype(JSType that)`
Checks whether `this` is a subtype of `that`.
`boolean`
`isUnknownType()`
We treat this as the unknown type if any of its implicit prototype properties is unknown.
`void`
`matchConstraint(JSType constraint)`
Modify this type so that it matches the specified type.
`boolean`
`matchesNumberContext()`
This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.
`boolean`
`matchesObjectContext()`
This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement.
`boolean`
`matchesStringContext()`
This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator.
`boolean`
`removeProperty(String name)`
Removes the declared or inferred property from this ObjectType.
`void`
`setJSDocInfo(JSDocInfo info)`
Sets the docInfo for this type from the given `JSDocInfo`.
`void`
`setPropertyJSDocInfo(String propertyName, JSDocInfo info)`
Sets the docInfo for the specified property from the `JSDocInfo` on its definition.
`TernaryValue`
`testForEquality(JSType that)`
Compares `this` and `that`.
`String`
`toDebugHashCodeString()`
A hash code function for diagnosing complicated issues around type-identity.
`EnumElementType`
`toMaybeEnumElementType()`
Downcasts this to an EnumElementType, or returns null if this is not an EnumElementType.
`EnumType`
`toMaybeEnumType()`
Downcasts this to an EnumType, or returns null if this is not an EnumType.
`FunctionType`
`toMaybeFunctionType()`
Downcasts this to a FunctionType, or returns null if this is not a function.
`TemplateType`
`toMaybeTemplateType()`
Downcasts this to a TemplateType, or returns null if this is not a function.
`TemplatizedType`
`toMaybeTemplatizedType()`
Downcasts this to a TemplatizedType, or returns null if this is not a function.
`UnionType`
`toMaybeUnionType()`
Downcasts this to a UnionType, or returns null if this is not a UnionType.
`<T> T`
`visit(Visitor<T> visitor)`
Visit this type with the given visitor.

### Methods inherited from class com.google.javascript.rhino.jstype.ObjectType

`cast, clearCachedValues, createDelegateSuffix, defineDeclaredProperty, defineInferredProperty, defineSynthesizedProperty, getCtorExtendedInterfaces, getDisplayName, getNormalizedReferenceName, getOwnPropertyJSDocInfo, getOwnPropertyNames, getOwnSlot, getParentScope, getPossibleToBooleanOutcomes, getPropertiesCount, getPropertyNames, getPropertyNode, getPropertyType, getRootNode, getSlot, hasCachedValues, hasOwnProperty, hasProperty, isFunctionPrototypeType, isObject, isPropertyInExterns, isPropertyTypeDeclared, isPropertyTypeInferred`

### Methods inherited from class com.google.javascript.rhino.jstype.JSType

`autobox, autoboxesTo, canCastTo, canTestForEqualityWith, canTestForShallowEqualityWith, clearResolved, dereference, differsFrom, equals, forceResolve, getGreatestSubtype, getLeastSupertype, getRestrictedTypeGivenToBooleanOutcome, getTypesUnderEquality, getTypesUnderInequality, getTypesUnderShallowEquality, getTypesUnderShallowInequality, hasAnyTemplateTypes, hasDisplayName, isArrayType, isBooleanObjectType, isBooleanValueType, isDateType, isEmptyType, isEnumElementType, isEnumType, isEquivalent, isEquivalentTo, isFunctionType, isGlobalThisType, isInvariant, isNominalConstructor, isNullType, isNumber, isNumberObjectType, isNumberValueType, isRecordType, isRegexpType, isResolved, isString, isStringObjectType, isStringValueType, isTemplateType, isTemplatizedType, isUnionType, isVoidType, matchesInt32Context, matchesUint32Context, resolve, restrictByNotNullOrUndefined, setValidator, toAnnotationString, toMaybeFunctionType, toMaybeTemplateType, toMaybeTemplatizedType, toObjectType, toString, unboxesTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Method Details

### getReferenceName

public String getReferenceName()
Description copied from class: `ObjectType`
Gets the reference name for this object. This includes named types like constructors, prototypes, and enums. It notably does not include literal types like strings and booleans and structural types.

Returns:
  the object's name or `null` if this is an anonymous object

### toMaybeTemplateType

public TemplateType toMaybeTemplateType()
Description copied from class: `JSType`
Downcasts this to a TemplateType, or returns null if this is not a function.

### hasAnyTemplateTypesInternal

public boolean hasAnyTemplateTypesInternal()

### visit

public <T> T visit(Visitor<T> visitor)
Description copied from class: `JSType`
Visit this type with the given visitor.

Returns:
  the value returned by the visitor
See Also:
  - `Visitor`

### hasReferenceName

public boolean hasReferenceName()
Description copied from class: `ObjectType`
Returns true if the object is named.

Overrides:
  `hasReferenceName` in class `ObjectType`
Returns:
  true if the object is named, false if it is anonymous

### matchesNumberContext

public boolean matchesNumberContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.

Overrides:
  `matchesNumberContext` in class `JSType`

### matchesStringContext

public boolean matchesStringContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator. All types have at least the potential for converting to `String`. When we add externally defined types, such as a browser OM, we may choose to add types that do not automatically convert to `String`.

Overrides:
  `matchesStringContext` in class `JSType`

### matchesObjectContext

public boolean matchesObjectContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement. Most types we will encounter, except notably `null`, have at least the potential for converting to `Object`. Host defined objects can get peculiar.

Overrides:
  `matchesObjectContext` in class `JSType`

### canBeCalled

public boolean canBeCalled()
Description copied from class: `JSType`
This predicate is used to test whether a given type can be used as the 'function' in a function call.

Overrides:
  `canBeCalled` in class `JSType`
Returns:
  `true` if this type might be callable.

### isNoType

public boolean isNoType()

Overrides:
  `isNoType` in class `JSType`

### isNoObjectType

public boolean isNoObjectType()

Overrides:
  `isNoObjectType` in class `JSType`

### isNoResolvedType

public boolean isNoResolvedType()

Overrides:
  `isNoResolvedType` in class `JSType`

### isUnknownType

public boolean isUnknownType()
Description copied from class: `ObjectType`
We treat this as the unknown type if any of its implicit prototype properties is unknown.

Overrides:
  `isUnknownType` in class `ObjectType`

### isCheckedUnknownType

public boolean isCheckedUnknownType()

Overrides:
  `isCheckedUnknownType` in class `JSType`

### isNullable

public boolean isNullable()
Description copied from class: `JSType`
Tests whether this type is nullable.

Overrides:
  `isNullable` in class `JSType`

### toMaybeEnumType

public EnumType toMaybeEnumType()
Description copied from class: `JSType`
Downcasts this to an EnumType, or returns null if this is not an EnumType.

Overrides:
  `toMaybeEnumType` in class `JSType`

### isConstructor

public boolean isConstructor()
Description copied from class: `JSType`
Whether this type is a `FunctionType` that is a constructor or a named type that points to such a type.

Overrides:
  `isConstructor` in class `JSType`

### isNominalType

public boolean isNominalType()
Description copied from class: `JSType`
Whether this type is a nominal type (a named instance object or a named enum).

Overrides:
  `isNominalType` in class `JSType`

### isInstanceType

public boolean isInstanceType()
Description copied from class: `JSType`
Whether this type is an Instance object of some constructor. Does not necessarily mean this is an `InstanceObjectType`.

Overrides:
  `isInstanceType` in class `JSType`

### isInterface

public boolean isInterface()
Description copied from class: `JSType`
Whether this type is a `FunctionType` that is an interface or a named type that points to such a type.

Overrides:
  `isInterface` in class `JSType`

### isOrdinaryFunction

public boolean isOrdinaryFunction()
Description copied from class: `JSType`
Whether this type is a `FunctionType` that is an ordinary function or a named type that points to such a type.

Overrides:
  `isOrdinaryFunction` in class `JSType`

### isAllType

public boolean isAllType()

Overrides:
  `isAllType` in class `JSType`

### isStruct

public boolean isStruct()
Description copied from class: `JSType`
Returns true iff `this` can be a `struct`. UnionType overrides the method, assume `this` is not a union here.

Overrides:
  `isStruct` in class `JSType`

### isDict

public boolean isDict()
Description copied from class: `JSType`
Returns true iff `this` can be a `dict`. UnionType overrides the method, assume `this` is not a union here.

Overrides:
  `isDict` in class `JSType`

### isNativeObjectType

public boolean isNativeObjectType()
Description copied from class: `ObjectType`
Whether this is a built-in object.

Overrides:
  `isNativeObjectType` in class `ObjectType`

### toMaybeUnionType

public UnionType toMaybeUnionType()
Description copied from class: `JSType`
Downcasts this to a UnionType, or returns null if this is not a UnionType. Named in honor of Haskell's Maybe type constructor.

Overrides:
  `toMaybeUnionType` in class `JSType`

### toMaybeFunctionType

public FunctionType toMaybeFunctionType()
Description copied from class: `JSType`
Downcasts this to a FunctionType, or returns null if this is not a function. For the purposes of this function, we define a MaybeFunctionType as any type in the sub-lattice { x | LEAST_FUNCTION_TYPE invalid input: '<'= x invalid input: '<'= GREATEST_FUNCTION_TYPE } This definition excludes bottom types like NoType and NoObjectType. This definition is somewhat arbitrary and axiomatic, but this is the definition that makes the most sense for the most callers.

Overrides:
  `toMaybeFunctionType` in class `JSType`

### toMaybeEnumElementType

public EnumElementType toMaybeEnumElementType()
Description copied from class: `JSType`
Downcasts this to an EnumElementType, or returns null if this is not an EnumElementType.

Overrides:
  `toMaybeEnumElementType` in class `JSType`

### testForEquality

public TernaryValue testForEquality(JSType that)
Description copied from class: `JSType`
Compares `this` and `that`.

Overrides:
  `testForEquality` in class `ObjectType`
Returns:
  - `TernaryValue.TRUE` if the comparison of values of `this` type and `that` always succeed (such as `undefined` compared to `null`)
  - `TernaryValue.FALSE` if the comparison of values of `this` type and `that` always fails (such as `undefined` compared to `number`)
  - `TernaryValue.UNKNOWN` if the comparison can succeed or fail depending on the concrete values

### isSubtype

public boolean isSubtype(JSType that)
Description copied from class: `JSType`
Checks whether `this` is a subtype of `that`.

Subtyping rules:

- (unknown) — every type is a subtype of the Unknown type.
- (no) — the No type is a subtype of every type.
- (no-object) — the NoObject type is a subtype of every object type (i.e. subtypes of the Object type).
- (ref) — a type is a subtype of itself.
- (union-l) — A union type is a subtype of a type U if all the union type's constituents are a subtype of U. Formally
  `(T<sub>1</sub>, &hellip;, T<sub>n</sub>) &lt;: U` if and only `T<sub>k</sub> &lt;: U` for all `k &isin; 1..n`.
- (union-r) — A type U is a subtype of a union type if it is a subtype of one of the union type's constituents. Formally
  `U &lt;: (T<sub>1</sub>, &hellip;, T<sub>n</sub>)` if and only if `U &lt;: T<sub>k</sub>` for some index `k`.
- (objects) — an Object `O<sub>1</sub>` is a subtype of an object `O<sub>2</sub>` if it has more properties than `O<sub>2</sub>` and all common properties are pairwise subtypes.

Overrides:
  `isSubtype` in class `JSType`
Returns:
  `this &lt;: that`

### getOwnerFunction

public FunctionType getOwnerFunction()
Description copied from class: `ObjectType`
Gets the owner of this if it's a function prototype.

Overrides:
  `getOwnerFunction` in class `ObjectType`

### getCtorImplementedInterfaces

public Iterable<ObjectType> getCtorImplementedInterfaces()
Description copied from class: `ObjectType`
Gets the interfaces implemented by the ctor associated with this type. Intended to be overridden by subclasses.

Overrides:
  `getCtorImplementedInterfaces` in class `ObjectType`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `JSType`

### getImplicitPrototype

public ObjectType getImplicitPrototype()
Description copied from class: `ObjectType`
Gets the implicit prototype (a.k.a. the `[[Prototype]]` property).

Specified by:
  `getImplicitPrototype` in class `ObjectType`

### removeProperty

public boolean removeProperty(String name)
Description copied from class: `ObjectType`
Removes the declared or inferred property from this ObjectType.

Overrides:
  `removeProperty` in class `ObjectType`
Parameters:
  `name` - the property's name
Returns:
  true if the property was removed successfully. False if the property did not exist, or could not be removed.

### findPropertyType

public JSType findPropertyType(String propertyName)
Description copied from class: `JSType`
Coerces this type to an Object type, then gets the type of the property whose name is given. Unlike `ObjectType.getPropertyType(java.lang.String)`, returns null if the property is not found.

Overrides:
  `findPropertyType` in class `ObjectType`
Returns:
  The property's type. `null` if the current type cannot have properties, or if the type is not found.

### getJSDocInfo

public JSDocInfo getJSDocInfo()
Description copied from class: `ObjectType`
Gets the docInfo for this type.

Overrides:
  `getJSDocInfo` in class `ObjectType`

### setJSDocInfo

public void setJSDocInfo(JSDocInfo info)
Description copied from class: `ObjectType`
Sets the docInfo for this type from the given `JSDocInfo`. The `JSDocInfo` may be `null`.

Overrides:
  `setJSDocInfo` in class `ObjectType`

### setPropertyJSDocInfo

public void setPropertyJSDocInfo(String propertyName, JSDocInfo info)
Description copied from class: `ObjectType`
Sets the docInfo for the specified property from the `JSDocInfo` on its definition.

Overrides:
  `setPropertyJSDocInfo` in class `ObjectType`
Parameters:
  `info` - `JSDocInfo` for the property definition. May be `null`.

### getConstructor

public FunctionType getConstructor()
Description copied from class: `ObjectType`
Gets this object's constructor.

Specified by:
  `getConstructor` in class `ObjectType`
Returns:
  this object's constructor or `null` if it is a native object (constructed natively v.s. by instantiation of a function)

### getTemplateTypes

public com.google.common.collect.ImmutableList<JSType> getTemplateTypes()
Description copied from class: `ObjectType`
Gets the declared default element type.

Overrides:
  `getTemplateTypes` in class `ObjectType`
See Also:
  - `TemplatizedType`

### toDebugHashCodeString

public String toDebugHashCodeString()
Description copied from class: `JSType`
A hash code function for diagnosing complicated issues around type-identity.

Overrides:
  `toDebugHashCodeString` in class `JSType`

### getTypeOfThis

public JSType getTypeOfThis()
Description copied from interface: `StaticScope`
Returns the expected type of `this` in the current scope.

Specified by:
  `getTypeOfThis` in interface `StaticScope<JSType>`
Overrides:
  `getTypeOfThis` in class `ObjectType`

### collapseUnion

public JSType collapseUnion()
Description copied from class: `JSType`
Gets the least supertype of this that's not a union.

Overrides:
  `collapseUnion` in class `JSType`

### matchConstraint

public void matchConstraint(JSType constraint)
Description copied from class: `JSType`
Modify this type so that it matches the specified type. This is useful for reverse type-inference, where we want to infer that an object literal matches its constraint (much like how the java compiler does reverse-inference to figure out generics).

Overrides:
  `matchConstraint` in class `JSType`
Parameters:
  `constraint` -

### toMaybeTemplatizedType

public TemplatizedType toMaybeTemplatizedType()
Description copied from class: `JSType`
Downcasts this to a TemplatizedType, or returns null if this is not a function.

Overrides:
  `toMaybeTemplatizedType` in class `JSType`

### getTemplateTypeMap

public TemplateTypeMap getTemplateTypeMap()
Description copied from class: `JSType`
Returns the template type map associated with this type.

Overrides:
  `getTemplateTypeMap` in class `JSType`